// SimpleCtrl.h : Declaration of the CSimpleCtrl

#ifndef __SIMPLECTRL_H_
#define __SIMPLECTRL_H_

#include "resource.h"       // main symbols
#include <atlctl.h>
#include "atltestCP.h"

#include <comdef.h>
#include <shlobj.h>


/////////////////////////////////////////////////////////////////////////////
// CSimpleCtrl
class ATL_NO_VTABLE CSimpleCtrl : 
	public CComObjectRootEx<CComSingleThreadModel>,
	public IDispatchImpl<ISimpleCtrl, &IID_ISimpleCtrl, &LIBID_ATLTESTLib>,
	public CComControl<CSimpleCtrl>,
	public IPersistStreamInitImpl<CSimpleCtrl>,
	public IOleControlImpl<CSimpleCtrl>,
	public IOleObjectImpl<CSimpleCtrl>,
	public IOleInPlaceActiveObjectImpl<CSimpleCtrl>,
	public IViewObjectExImpl<CSimpleCtrl>,
	public IOleInPlaceObjectWindowlessImpl<CSimpleCtrl>,
	public ISupportErrorInfo,
	public IConnectionPointContainerImpl<CSimpleCtrl>,
	public IPersistStorageImpl<CSimpleCtrl>,
	public ISpecifyPropertyPagesImpl<CSimpleCtrl>,
	public IQuickActivateImpl<CSimpleCtrl>,
	public IDataObjectImpl<CSimpleCtrl>,
	public IProvideClassInfo2Impl<&CLSID_SimpleCtrl, &DIID__ISimpleCtrlEvents, &LIBID_ATLTESTLib>,
	public IPropertyNotifySinkCP<CSimpleCtrl>,
	public CComCoClass<CSimpleCtrl, &CLSID_SimpleCtrl>,
	public IPersistPropertyBagImpl<CSimpleCtrl>,
	public IObjectSafetyImpl<CSimpleCtrl, INTERFACESAFE_FOR_UNTRUSTED_CALLER | INTERFACESAFE_FOR_UNTRUSTED_DATA>,
	public CProxy_ISimpleCtrlEvents< CSimpleCtrl >
{
public:
	CSimpleCtrl()
	{
		m_bWindowOnly = true;
	}

DECLARE_REGISTRY_RESOURCEID(IDR_SIMPLECTRL)

DECLARE_PROTECT_FINAL_CONSTRUCT()

BEGIN_COM_MAP(CSimpleCtrl)
	COM_INTERFACE_ENTRY(ISimpleCtrl)
	COM_INTERFACE_ENTRY(IDispatch)
	COM_INTERFACE_ENTRY(IViewObjectEx)
	COM_INTERFACE_ENTRY(IViewObject2)
	COM_INTERFACE_ENTRY(IViewObject)
	COM_INTERFACE_ENTRY(IOleInPlaceObjectWindowless)
	COM_INTERFACE_ENTRY(IOleInPlaceObject)
	COM_INTERFACE_ENTRY2(IOleWindow, IOleInPlaceObjectWindowless)
	COM_INTERFACE_ENTRY(IOleInPlaceActiveObject)
	COM_INTERFACE_ENTRY(IOleControl)
	COM_INTERFACE_ENTRY(IOleObject)
	COM_INTERFACE_ENTRY(IPersistStreamInit)
	COM_INTERFACE_ENTRY2(IPersist, IPersistStreamInit)
	COM_INTERFACE_ENTRY(ISupportErrorInfo)
	COM_INTERFACE_ENTRY(IConnectionPointContainer)
	COM_INTERFACE_ENTRY(ISpecifyPropertyPages)
	COM_INTERFACE_ENTRY(IQuickActivate)
	COM_INTERFACE_ENTRY(IPersistStorage)
	COM_INTERFACE_ENTRY(IDataObject)
	COM_INTERFACE_ENTRY(IProvideClassInfo)
	COM_INTERFACE_ENTRY(IProvideClassInfo2)
	COM_INTERFACE_ENTRY(IPersistPropertyBag)
	COM_INTERFACE_ENTRY(IObjectSafety)
	COM_INTERFACE_ENTRY_IMPL(IConnectionPointContainer)
END_COM_MAP()

BEGIN_PROP_MAP(CSimpleCtrl)
	PROP_DATA_ENTRY("_cx", m_sizeExtent.cx, VT_UI4)
	PROP_DATA_ENTRY("_cy", m_sizeExtent.cy, VT_UI4)
	PROP_ENTRY("DisplayString", 1, GetObjectCLSID())
	// Example entries
	// PROP_ENTRY("Property Description", dispid, clsid)
	// PROP_PAGE(CLSID_StockColorPage)
END_PROP_MAP()

BEGIN_CONNECTION_POINT_MAP(CSimpleCtrl)
	CONNECTION_POINT_ENTRY(IID_IPropertyNotifySink)
	CONNECTION_POINT_ENTRY(DIID__ISimpleCtrlEvents)
END_CONNECTION_POINT_MAP()

BEGIN_MSG_MAP(CSimpleCtrl)
	CHAIN_MSG_MAP(CComControl<CSimpleCtrl>)
	DEFAULT_REFLECTION_HANDLER()
	MESSAGE_HANDLER(WM_LBUTTONDOWN, OnLButtonDown)
	MESSAGE_HANDLER(WM_CREATE, OnCreate)
	MESSAGE_HANDLER(WM_DESTROY, OnDestroy)
END_MSG_MAP()
// Handler prototypes:
//  LRESULT MessageHandler(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);
//  LRESULT CommandHandler(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled);
//  LRESULT NotifyHandler(int idCtrl, LPNMHDR pnmh, BOOL& bHandled);



// ISupportsErrorInfo
	STDMETHOD(InterfaceSupportsErrorInfo)(REFIID riid)
	{
		static const IID* arr[] = 
		{
			&IID_ISimpleCtrl,
		};
		for (int i=0; i<sizeof(arr)/sizeof(arr[0]); i++)
		{
			if (InlineIsEqualGUID(*arr[i], riid))
				return S_OK;
		}
		return S_FALSE;
	}

// IViewObjectEx
	DECLARE_VIEW_STATUS(VIEWSTATUS_SOLIDBKGND | VIEWSTATUS_OPAQUE)

// ISimpleCtrl
public:
	STDMETHOD(get_DisplayString)(/*[out, retval]*/ BSTR *pVal);
	STDMETHOD(put_DisplayString)(/*[in]*/ BSTR newVal);

	HRESULT OnDraw(ATL_DRAWINFO& di)
	{
		RECT& rc = *(RECT*)di.prcBounds;
		Rectangle(di.hdcDraw, rc.left, rc.top, rc.right, rc.bottom);

		SetTextAlign(di.hdcDraw, TA_CENTER|TA_BASELINE);
		//LPCTSTR pszText = _T("ATL 3.0 : SampleCtrl");
		char szString[MAX_PATH];
		WideCharToMultiByte(949, 0, (LPCWSTR)m_DisplayString, -1, szString, MAX_PATH, NULL, NULL);
		TextOut(di.hdcDraw, 
			(rc.left + rc.right) / 2, 
			(rc.top + rc.bottom) / 2, 
			szString, 
			lstrlen(szString));

		return S_OK;
	}

private:
	IWebBrowser2* GetWeb();
	bool CallJavaScript(char* sz);

private:
	IWebBrowser2*  m_iWeb;

private:
	CComBSTR m_DisplayString;

	LRESULT OnLButtonDown(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
	{
		// TODO : Add Code for message handler. Call DefWindowProc if necessary.
/*
		if (PtInRegion(hRgn, xPos, yPos))
			Fire_ClickIn(xPos, yPos);
		else
			Fire_ClickOut(xPos, yPos);
*/
		m_DisplayString = L" 콺 ư ";
		// Ʈ   Ѵ. 
		SetDirty(TRUE);
		//  ̳ʿ Ѵ. 
		FireViewChange();

		return 0;
	}
	LRESULT OnCreate(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
	{
		// TODO : Add Code for message handler. Call DefWindowProc if necessary.
		//MessageBox("WM_CREATE", "Test", MB_OK);
		//Fire_SendMsgBox(777);
		m_iWeb = GetWeb();
		CallJavaScript("babo");
		return 0;
	}
	LRESULT OnDestroy(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
	{
		// TODO : Add Code for message handler. Call DefWindowProc if necessary.
		m_iWeb->Release();
		m_iWeb = NULL;
		return 0;
	}
};

#endif //__SIMPLECTRL_H_
